<template>
  <ob-form class="form-content" :is-show-controls="false" :formData="formData">
    <p>Усредненным прецедентный тариф вычисляется на основании тарифов уже исполненных заказов, разделенных по степени давности.</p>
    <formula :items="AVERAGE_RATE_FORMULA" />

    <div>
      <h2 class="section-title">Коэффициенты актуальности и интервалы давности</h2>
      <p>Коэффициенты актуальности a,b,c вводятся в интервале [0; 1], причем a + b + c = 1. Группы давности характеризуются соответствующим настраиваемым интервалом.</p>
      <div class="row middles-xs progress-bar">
        <div
          class="progress-bar-section"
          :style="{flex: `${this.model.distant_interval/this.distantEnd}`}"
        >
          <div class="box">
            <span class="box-tip">Давние тарифы</span>
            <span class="bar old-tariffs"></span>
            <span class="bar-tip oldest-value">{{ distantEnd }} дней</span>
          </div>
        </div>
        <div class="progress-bar-section" :style="{flex: `${this.model.recent_interval/this.distantEnd}`}">
          <div class="box">
            <span class="box-tip">Недавние тарифы</span>
            <span class="bar recent-tariffs"></span>
            <span class="bar-tip recent-value">{{ recent }} дней</span>
          </div>
        </div>
        <div
          class="progress-bar-section"
          :style="{flex: `${this.model.nearest_interval/this.distantEnd}`}"
        >
          <div class="box">
            <span class="box-tip">Ближайшие тарифы</span>
            <span class="bar nearest-tariffs"></span>
            <span class="bar-tip nearest-value">{{ model.nearest_interval }} дней</span>
            <span class="bar-tip today-value">Сегодня</span>
          </div>
        </div>
      </div>

      <div class="row middle-xs">
        <div class="col-label">
          <div class="box">Ближайшие тарифы</div>
        </div>
        <div class="col-input">
          <div class="box">
            <ob-input label="От" type="text" value="Сегодня" readonly />
          </div>
        </div>
        <div class="col-input">
          <div class="box">
            <ob-input
              label="До, дней назад"
              type="number"
              :value="model.nearest_interval"
              @input="emitChanges('nearest_interval', $event)"
            />
          </div>
        </div>
        <div class="col-symbol">
          <div class="box symbol-box">a</div>
        </div>
        <div class="col-input-sm">
          <div class="box">
            <ob-input
              type="money:3"
              :value="model.coef_a"
              @input="emitChanges('coef_a', $event)"
              :is-valid="!coefError"
              validation-message="Сумма коэффициентов должна быть равна 1. Каждый коэффициент должен быть не меньше 0 и не больше 1"
              :is-convert-money="false"
              is-dirty-force
            />
          </div>
        </div>
      </div>
      <div class="row middle-xs">
        <div class="col-label">
          <div class="box">Недавние тарифы</div>
        </div>
        <div class="col-input">
          <div class="box">
            <ob-input label="От, дней назад" type="number" :value="+model.nearest_interval + 1" readonly />
          </div>
        </div>
        <div class="col-input">
          <div class="box">
            <ob-input
              label="До, дней назад"
              type="number"
              :value="recent"
              :is-valid="recentError ? false : null"
              validation-message="Не может быть меньше ближайших тарифов"
              @input="updateRecentInterval"
              @blur="commitRecentInterval"
            />
          </div>
        </div>
        <div class="col-symbol">
          <div class="box symbol-box">b</div>
        </div>
        <div class="col-input-sm">
          <div class="box">
            <ob-input
              type="money:3"
              :value="model.coef_b"
              @input="emitChanges('coef_b', $event)"
              :is-valid="!coefError"
              validation-message="Сумма коэффициентов должна быть равна 1. Каждый коэффициент должен быть не меньше 0 и не больше 1"
              :is-convert-money="false"
              is-dirty-force
            />
          </div>
        </div>
      </div>
      <div class="row middle-xs">
        <div class="col-label">
          <div class="box">Давние тарифы</div>
        </div>
        <div class="col-input">
          <div class="box">
            <ob-input label="От, дней назад" :value="distantStart" type="text" readonly />
          </div>
        </div>
        <div class="col-input">
          <div class="box">
            <ob-input
              label="До, дней назад"
              type="number"
              :value="distantEnd"
              :is-valid="distantError ? false : null"
              validation-message="Не может быть меньше недавних тарифов"
              @input="updateDistantInterval"
              @blur="commitDistantInterval"
            />
          </div>
        </div>
        <div class="col-symbol">
          <div class="box symbol-box">c</div>
        </div>
        <div class="col-input-sm">
          <div class="box">
            <ob-input
              type="money:3"
              :value="model.coef_c"
              @input="emitChanges('coef_c', $event)"
              :is-valid="!coefError"
              validation-message="Сумма коэффициентов должна быть равна 1. Каждый коэффициент должен быть не меньше 0 и не больше 1"
              :is-convert-money="false"
              is-dirty-force
            />
          </div>
        </div>
      </div>
    </div>
  </ob-form>
</template>

<script>
import ObForm from 'common-components/src/obComponents/obForm';
import ObInput from 'common-components/src/obComponents/obInput';
import formula from '../../../../basePricesPage/components/StaticFormula';
import { mapActions } from 'vuex';

const AVERAGE_RATE_FORMULA = [
  {
    label: 'T',
    index: 'геогр.',
    tipAbove: '',
    tipBelow: 'УСРЕДНЕННЫЙ ТАРИФ',
    tipPositionClass: 'align-right',
    tipSizeClass: 'narrow',
  },
  {
    label: '=',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: 'c',
    index: '',
    tipAbove: 'КОЭФФИЦИЕНТ АКТУАЛЬНОСТИ ДАВНИХ ТАРИФОВ',
    tipBelow: '',
    tipPositionClass: 'align-right',
    tipSizeClass: 'narrow',
  },
  {
    label: 'T',
    index: 'давн.',
    tipAbove: '',
    tipBelow: 'СРЕДНЕЕ АРИФМЕТИЧЕСКОЕ МНОЖЕСТВА ДАВНИХ ТАРИФОВ',
    tipPositionClass: 'align-center',
    tipSizeClass: 'narrow',
  },
  {
    label: '+',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: 'b',
    index: '',
    tipAbove: 'КОЭФФИЦИЕНТ АКТУАЛЬНОСТИ НЕДАВНИХ ТАРРИФОВ',
    tipBelow: '',
    tipPositionClass: 'align-center',
    tipSizeClass: 'narrow',
  },
  {
    label: 'T',
    index: 'недавн.',
    tipAbove: '',
    tipBelow: 'СРЕДНЕЕ АРИФМЕТИЧЕСКОЕ МНОЖЕСТВА НЕДАВНИХ ТАРИФОВ',
    tipPositionClass: 'align-left',
    tipSizeClass: 'narrow',
  },
  {
    label: '+',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: 'a',
    index: '',
    tipAbove: 'КОЭФФИЦИЕНТ АКТУАЛЬНОСТИ БЛИЖАЙШИХ ТАРИФОВ',
    tipBelow: '',
    tipPositionClass: 'align-center',
    tipSizeClass: 'mid',
  },
  {
    label: 'T',
    index: 'ближ.',
    tipAbove: '',
    tipBelow: 'СРЕДНЕЕ АРИФМЕТИЧЕСКОЕ МНОЖЕСТВА БЛИЖАЙШИХ ТАРИФОВ',
    tipPositionClass: 'align-left',
    tipSizeClass: 'narrow',
  },
];

export default {
  name: 'AverageRateTab',
  components: {
    ObForm,
    ObInput,
    formula,
  },
  data() {
    return {
      recentDaysBefore: null,
      distantDaysBefore: null,
      recentError: false,
      distantError: false,
      formData: {},
      AVERAGE_RATE_FORMULA
    };
  },
  computed: {
    ...mapGetters({
      model: 'base_prices/mathModel',
    }),
    recent() {
      return +this.model.nearest_interval + +this.model.recent_interval;
    },
    distantStart() {
      return +this.recent + 1;
    },
    distantEnd() {
      return +this.recent + +this.model.distant_interval;
    },
    coefError() {
      const coeffs = [this.model.coef_a, this.model.coef_b, this.model.coef_c].map(n => +n);

      const notInRange = coeffs.some(value => value < 0 || value > 1);
      const sumIsNotEquals =
        coeffs.reduce((acc, value) => +(acc + value).toFixed(3), 0) !== 1;

      return notInRange || sumIsNotEquals;
    },
  },
  methods: {
    ...mapActions({
      setMathModelErrorStatus: `base_prices/setMathModelErrorStatus`,
      setMathModelField: 'base_prices/setMathModelField',
    }),
    emitChanges(name, value) {
      this.setMathModelField({
        name,
        value,
      });
    },

    updateRecentInterval(value) {
      this.recentError = false;
      this.recentDaysBefore = value;
    },
    commitRecentInterval() {
      const delta = this.recentDaysBefore - this.model.nearest_interval;
      if (delta < 1) {
        this.recentError = true;
        return;
      }
      this.emitChanges('recent_interval', delta);
    },

    updateDistantInterval(value) {
      this.distantError = false;
      this.distantDaysBefore = value;
    },
    commitDistantInterval() {
      const delta = this.distantDaysBefore - this.recent;
      if (delta < 1) {
        this.distantError = true;
        return;
      }
      this.emitChanges('distant_interval', delta);
    },
  },
  watch: {
    coefError(value) {
      this.$nextTick(() => {
        this.setMathModelErrorStatus({ name: 'coef', value });
      });
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;
$cornflower-craiola: #99b7e9;
$light-denim: #336fd3;

@import '../../../../../../node_modules/common-components/src/static/css/mixins';

.formula-block {
  padding: 90px 0;
}

::v-deep {
  .formula-block__element__symbol {
    margin: 0 14px;
  }
  .formula-block__element__bottom-tip__body.narrow.align-left {
    left: 25px;
  }
}

.section-title {
  @include font-mixin(16px, 20px, bold, $cobalt-black, 0.4px);

  padding-top: 20px;
  margin-bottom: 20px;
  + p {
    margin: 0 0 20px;
  }
}

.progress-bar {
  margin: 0;
  padding: 15px 0 30px;
  flex-wrap: nowrap;

  .progress-bar-section {
    position: relative;
    padding: 0;
    min-width: fit-content;

    .box {
      text-align: center;
      @include font-mixin(12px, 14px, 400, $cobalt-black, 0.2px);
      text-transform: uppercase;

      &-tip {
        width: 100px;
        display: block;
        margin: 0 auto 10px;
        word-break: break-word;
      }
    }

    .bar {
      display: block;
      height: 12px;
      position: relative;

      &:after {
        content: '';
        position: absolute;
        z-index: 1;
        right: -6px;
        border-top: 6px solid transparent;
        border-bottom: 6px solid transparent;
      }

      &.old-tariffs {
        background: #d6e2f6;

        &:after {
          border-left: 6px solid #d6e2f6;
        }
      }

      &.recent-tariffs {
        background: $cornflower-craiola;

        &:after {
          border-left: 6px solid $cornflower-craiola;
        }
      }

      &.nearest-tariffs {
        background: $light-denim;

        &:after {
          border-left: 6px solid $light-denim;
        }
      }
    }

    .bar-tip {
      @include font-mixin(12px, 14px, 400, #9da0ac, 0.4px);
      text-transform: uppercase;
      display: block;
      margin-top: 10px;

      &.oldest-value,
      &.recent-value,
      &.nearest-value {
        float: left;
      }

      &.recent-value,
      &.nearest-value {
        margin-left: -25px;
      }

      &.today-value {
        float: right;
      }
    }
  }
}

.symbol-box {
  @include font-mixin(32px, 37px, 400, $shale-gray, 0.2px);
  text-align: center;

  sub {
    font-size: 12px;
    text-transform: uppercase;
  }
}

.col {
  &-label {
    width: 140px;
    margin-right: 20px;
  }
  &-input {
    width: 200px;
    margin-right: 20px;
  }
  &-symbol {
    width: 18px;
    margin: 0 20px;
  }
  &-input-sm {
    width: 142px;
  }
}

.box-input {
  width: 70px;
}
</style>
